var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import Picture from "./Picture";
import React from "react";
import PropTypes from "prop-types";
import { css } from "glamor";

var FullSizePicture = function (_React$PureComponent) {
    _inherits(FullSizePicture, _React$PureComponent);

    function FullSizePicture() {
        _classCallCheck(this, FullSizePicture);

        return _possibleConstructorReturn(this, _React$PureComponent.apply(this, arguments));
    }

    FullSizePicture.prototype.getStyles = function getStyles() {
        var styles = {
            overflow: "hidden",
            width: "100%",
            height: "100%",
            position: "relative"
        };

        return css(styles, this.props.style);
    };

    FullSizePicture.prototype.getImageWrapperStyles = function getImageWrapperStyles() {
        return css({
            position: "absolute",
            top: "-50%",
            width: "200%",
            left: "-50%",
            height: "200%"
        });
    };

    FullSizePicture.prototype.getImageStyles = function getImageStyles() {
        var styles = {
            position: "absolute",
            top: 0,
            left: 0,
            bottom: 0,
            right: 0,
            margin: "auto",
            minWidth: "50%",
            minHeight: "50%"
        };

        return css(styles, this.props.imageStyle);
    };

    FullSizePicture.prototype.render = function render() {
        return React.createElement(
            "div",
            _extends({ className: this.props.className }, this.getStyles()),
            React.createElement(
                "div",
                this.getImageWrapperStyles(),
                React.createElement(Picture, {
                    alt: this.props.alt,
                    src: this.props.src,
                    sources: this.props.sources,
                    style: this.getImageStyles()
                })
            )
        );
    };

    return FullSizePicture;
}(React.PureComponent);

FullSizePicture.propTypes = {
    className: PropTypes.string,
    alt: PropTypes.string,
    sources: PropTypes.array,
    src: PropTypes.string,
    style: PropTypes.oneOfType([PropTypes.array, PropTypes.object]),
    imageStyle: PropTypes.oneOfType([PropTypes.array, PropTypes.object])
};

export default FullSizePicture;